//+------------------------------------------------------------------+
//|                                           MA Cross and Money.mq4 |
//|                                      Copyright  2006, Eli hayun |
//|                                          http://www.elihayun.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Eli hayun"
#property link      "http://www.elihayun.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Crimson
#property indicator_color2 SeaGreen
//---- input parameters
extern int       maSlow=35;
extern int       maFast=5;
extern bool      ShowLines=true;
//---- buffers
double UpBuffer[];
double DownBuffer[];

double AvgVol = 61;
string Curr = "";
int TimeFrame = 0;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   //SetIndexStyle(0,DRAW_ARROW,STYLE_SOLID,0);
   //SetIndexArrow(0,233);   //241,129
   //SetIndexBuffer(0,UpBuffer);
   //SetIndexEmptyValue(0,0.0);
   //SetIndexStyle(1,DRAW_ARROW,STYLE_SOLID,0);          // Arrows turned off
   //SetIndexArrow(1,234);   //242,129
   //SetIndexBuffer(1,DownBuffer);
   //SetIndexEmptyValue(1,0.0);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   static bool bFirst = true;
   
    int iBar,nCountedBars;
   int counted_bars=IndicatorCounted();
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;

   int limit=Bars-counted_bars;
   
      
   
   Curr = Symbol();
   TimeFrame = Period(); //PERIOD_M15;
   
   if (bFirst)
   {
      bFirst = false;
      CalcAvgVol();
   }
   
   AvgVol = 61;
   
   for(iBar = 0; iBar <= limit; iBar++)
   {
   
      int counter=iBar;
      double Range=0;
      double AvgRange=0;
      
      for (counter=iBar ;counter<=iBar+9;counter++)
      {
         AvgRange=AvgRange+MathAbs(High[counter]-Low[counter]);
      }
      Range=AvgRange/10;

      UpBuffer[iBar+1] = 0; DownBuffer[iBar+1] = 0;
      int iCross = maCrossed(iBar+1);
      if (iCross != 0)
      {
         //if (MoneyEntered(iBar+1))
            if (iCross == 1)
            {
               if (NewBar() && (iBar < 3))
               {
                  Alert(Symbol()," ",(Period())," ", "X/Up"," - ",Bid); // Bid gives actual price on graph
                  PlaySound("alert.wav");
               }
               UpBuffer[iBar+1] = iLow(Curr, Period(), iBar+1) - 0.5 * Range;
            }
           
            {
               if (NewBar() && (iBar < 3))
               {
                  Alert(Symbol()," ",(Period())," ", "X/Down"," - ",Bid);  //Bid gives actual price on graph
                  PlaySound("alert.wav");
               }
               DownBuffer[iBar+1] = iHigh(Curr, Period(), iBar+1) + 0.5 * Range;
            }
            
            
            DisplayIndicators();
      }
   }
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+

bool NewBar()
{
   int p = TimeFrame;
   static datetime dtCurrTime = 0;
   
   if (iTime(Curr, p, 0) != dtCurrTime)
   {
      dtCurrTime = iTime(Curr, p , 0);
      return(true);
   }
   return(false);
}


// Calculate the volume average
void CalcAvgVol()
{
   double sum = 0.0;
   for(int ii=1; ii<201; ii++)
   {
      sum += iVolume(Curr, TimeFrame, ii);
   }
   AvgVol = sum / 200;
  
  
  AvgVol = 61;
}


int maCrossed(int i)
{
      double maFastnow = iMA(Curr, TimeFrame, maFast, 0, MODE_EMA, PRICE_CLOSE, i);
      double maFastprevious = iMA(Curr, TimeFrame, maFast, 0, MODE_EMA, PRICE_CLOSE, i+1);
      double maFastafter = iMA(Curr, TimeFrame, maFast, 0, MODE_EMA, PRICE_CLOSE, i-1);

      double maSlownow = iMA(Curr, TimeFrame, maSlow, 0, MODE_EMA, PRICE_CLOSE, i);
      double maSlowprevious = iMA(Curr, TimeFrame, maSlow, 0, MODE_EMA, PRICE_CLOSE, i+1);
      double maSlowafter = iMA(Curr, TimeFrame, maSlow, 0, MODE_EMA, PRICE_CLOSE, i-1);
      
      if ((maFastnow > maSlownow) && (maFastprevious < maSlowprevious)) {// && (maFastafter > maSlowafter)) {
         return(1);
      }
      else if ((maFastnow < maSlownow) && (maFastprevious > maSlowprevious)) { // && (maFastafter < maSlowafter)) {
         return(-1);
      }
 
      return(0);
}


void DisplayIndicators()
{
   double rsi_h4 = iRSI(NULL, PERIOD_H4, 9, PRICE_CLOSE, 0);
   double rsi_h1 = iRSI(NULL, PERIOD_H1, 9, PRICE_CLOSE, 0);
   double rsi_m15 = iRSI(NULL, PERIOD_M15, 9, PRICE_CLOSE, 0);
   double rsi_m5 = iRSI(NULL, PERIOD_M5, 9, PRICE_CLOSE, 0);
   double rsi_m1 = iRSI(NULL, PERIOD_M1, 9, PRICE_CLOSE, 0);
   
   double stoc_H4 = iStochastic(NULL, PERIOD_H4, 15,5,5, MODE_EMA, 0, MODE_SIGNAL, 0);
   double stoc_H1 = iStochastic(NULL, PERIOD_H1, 15,5,5, MODE_EMA, 0, MODE_SIGNAL, 0);
   double stoc_M15 = iStochastic(NULL, PERIOD_M15, 15,5,5, MODE_EMA, 0, MODE_SIGNAL, 0);
   double stoc_M5 = iStochastic(NULL, PERIOD_M5, 15,5,5, MODE_EMA, 0, MODE_SIGNAL, 0);
   double stoc_M1 = iStochastic(NULL, PERIOD_M1, 15,5,5, MODE_EMA, 0, MODE_SIGNAL, 0);
   
   double cci_HH4 = iCCI(NULL, PERIOD_H4,13, PRICE_CLOSE, 0);
   double cci_HH1 = iCCI(NULL, PERIOD_H1,13, PRICE_CLOSE, 0);      // CCI Added in to help stop false signals
   double cci_MM15 = iCCI(NULL, PERIOD_M15,13, PRICE_CLOSE, 0);    // Added in 5 Min to give early warning of direction change
   double cci_MM5 = iCCI(NULL, PERIOD_M5,13, PRICE_CLOSE, 0);      // Added 4 Hour to give overall perspective 
   double cci_MM1 = iCCI(NULL, PERIOD_M1,13, PRICE_CLOSE, 0);
   
   string rsi_rec_h1 = "", rsi_rec_m15 = "", rsi_rec_m5 = "", rsi_rec_m1 = "", rsi_rec_h4 = "";
   
   if ((rsi_h4 > 50) && (stoc_H4 > 40) && (cci_HH1 > 0)) { rsi_rec_h4 = "Buy"; }
   if ((rsi_h1 > 50) && (stoc_H1 > 40) && (cci_HH1 > 0)) { rsi_rec_h1 = "Buy"; }
   if ((rsi_m15 > 50) && (stoc_M15 > 40) && (cci_MM15 > 0)) { rsi_rec_m15 = "Buy"; }
   if ((rsi_m5 > 50) && (stoc_M5 > 40) && (cci_MM5 > 0)) { rsi_rec_m5 = "Buy"; }
   if ((rsi_m1 > 50) && (stoc_M1 > 40) && (cci_MM1 > 0)) { rsi_rec_m1 = "Buy"; }
   
   if ((rsi_h4 < 50) && (stoc_H4 < 60) && (cci_HH4 < 0)) { rsi_rec_h4 = "Sell"; }
   if ((rsi_h1 < 50) && (stoc_H1 < 60) && (cci_HH1 < 0)) { rsi_rec_h1 = "Sell"; }
   if ((rsi_m15 < 50) && (stoc_M15 < 60) && (cci_MM15 < 0)) { rsi_rec_m15 = "Sell"; }
   if ((rsi_m5 < 50) && (stoc_M5 < 60) && (cci_MM5 < 0)) { rsi_rec_m5 = "Sell"; }
   if ((rsi_m1 < 50) && (stoc_M1 < 60) && (cci_MM1 < 0)) { rsi_rec_m1 = "Sell"; }
   

   string sComment = "H4    RSI: " + DoubleToStr(rsi_h4,0) + " Stoc: " + DoubleToStr(stoc_H4,0) + " CCI: " + DoubleToStr(cci_HH4,0)+ "    " + rsi_rec_h4 + "\n"
                    +"H1    RSI: " + DoubleToStr(rsi_h1,0) + " Stoc: " + DoubleToStr(stoc_H1,0) + " CCI: " + DoubleToStr(cci_HH1,0)+ "    " + rsi_rec_h1 + "\n"
                    +"M15  RSI: " + DoubleToStr(rsi_m15,0)+ " Stoc: " + DoubleToStr(stoc_M15,0) + " CCI: " + DoubleToStr(cci_MM15,0)+ "   " + rsi_rec_m15 + "\n"
                    +"M5   RSI: " + DoubleToStr(rsi_m5,0)+ " Stoc: " + DoubleToStr(stoc_M5,0) + " CCI: " + DoubleToStr(cci_MM5,0)+ "     " + rsi_rec_m5 + "\n"
                    +"M1   RSI: " + DoubleToStr(rsi_m1,0)+ " Stoc: " + DoubleToStr(stoc_M1,0) + " CCI: " + DoubleToStr(cci_MM1,0)+ "     " + rsi_rec_m1 ;
                 
   Comment(sComment);
   
  
   
}